<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Variable Features</TITLE>
<link href="suif1_57.html" rel=Next>
<link href="suif1_55.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_55.html">previous</A>, <A HREF="suif1_57.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC56" HREF="suif1_toc.html#TOC56">Basic Features of Variables</A></H3>

<P>
<A NAME="IDX373"></A>
<A NAME="IDX374"></A>
The type of a variable can be accessed via the <CODE>type</CODE> and
<CODE>set_type</CODE> methods.  The type must be visible in the scope where
the variable is defined.  Since the type specifies the amount of storage
occupied by the variable, the size of the type must not be zero.  This
means that function types, void types, incomplete structure and union
types, and array types with unknown bounds cannot be used for variables
<A NAME="DOCF4" HREF="suif1_foot.html#FOOT4">(4)</A>.  Pointers to those types are acceptable, of course.
Sub-variables may have any type so long as the size of that type and
the sub-variable's offset allow it to remain within the parent
variable.

</P>
<P>
<A NAME="IDX375"></A>
<A NAME="IDX376"></A>
<A NAME="IDX377"></A>
<A NAME="IDX378"></A>
<A NAME="IDX379"></A>
Variable symbols may also be allocated to machine registers.  A flag is
used to indicate variables that are contained in registers; the
<CODE>is_reg</CODE> method returns the value of this flag and the
<CODE>set_reg</CODE> and <CODE>reset_reg</CODE> methods change its value.  The
<CODE>reg_num</CODE> annotation can be attached to a register variable to
specify the corresponding machine register number (see section <A HREF="suif1_78.html#SEC78">Miscellaneous Annotations</A>).  Variables cannot be registers if they have variable
definitions.  Whether a sub-variable is a register or not is slaved to
this property in its parent.

</P>
<P>
<A NAME="IDX380"></A>
<A NAME="IDX381"></A>
Symbols for variables that are not allocated on the stack must have
separate variable definitions (see section <A HREF="suif1_58.html#SEC58">Variable Definitions</A>) or else
they are merely declarations of external symbols.  The
<CODE>has_var_def</CODE> method checks if a variable symbol has a separate
definition, and the <CODE>definition</CODE> method returns a pointer to the
definition.  It is an error to call <CODE>definition</CODE> for a variable
that does not have a definition, so be sure to check first.
Sub-variables are never allowed to have their own definitions.

</P>
<P>
<A NAME="IDX382"></A>
<A NAME="IDX383"></A>
The <CODE>var_sym</CODE> class includes several methods to check various
attributes and flags for variables.  The <CODE>is_auto</CODE> method checks if
a variable is in the automatic storage class, i.e. if it will be
allocated on the stack.  Global variables and static local variables
(those with variable definitions) are not automatic and <CODE>is_auto</CODE>
returns <CODE>FALSE</CODE> for them; other variables are automatic.  The
<CODE>is_static</CODE> method is the opposite of <CODE>is_auto</CODE>, except that
register variables are not considered to be static.

</P>
<P>
<A NAME="IDX384"></A>
<A NAME="IDX385"></A>
<A NAME="IDX386"></A>
The formal parameters of a procedure are represented by variables that
have a special flag set.  The <CODE>is_param</CODE> method returns the value
of this flag, and the <CODE>set_param</CODE> and <CODE>reset_param</CODE> methods
change its value.  Identifying the formals with flags does not allow
their order to be specified, so the procedure symbol table maintains a
list of the formals (see section <A HREF="suif1_44.html#SEC44">Procedure Symbol Tables</A>).  All of the
variables for which <CODE>is_param</CODE> returns <CODE>TRUE</CODE> should be on the
list of parameters, and conversely, all variables on the parameter list
should have the flag set.  Sub-variables are not allowed to be
parameters; sub-variables of parameters are allowed, but these are not
considered parameters themselves.

</P>
<P>
<A NAME="IDX387"></A>
<A NAME="IDX388"></A>
<A NAME="IDX389"></A>
Because many compiler optimizations are only applicable to variables
that are not aliased, it is important to identify such variables.  Each
variable symbol includes a flag to indicate whether the variable has its
address taken, and thus whether it could be aliased.  The
<CODE>is_addr_taken</CODE> method returns the value of this flag.  The
front-end should set these flags, but they may also need to be updated
as the code is transformed.  The <CODE>set_addr_taken</CODE> and
<CODE>reset_addr_taken</CODE> methods can be used to change the flag for a
particular variable symbol.  For sub-variables, this property is
slaved to this property in the parent variable.

</P>
<P>
<A NAME="IDX390"></A>
Besides requiring that variables not be aliased, most optimizations also
do not apply to aggregate data structures.  The <CODE>is_scalar</CODE> method
checks the type of a variable symbol and returns <CODE>TRUE</CODE> if it is
not an aggregate type.  Arrays, structures, and unions are considered to
be aggregates.

</P>
<P>
<A NAME="IDX391"></A>
In general, most optimizations target scalar variables that are
guaranteed not to be aliased.  Since it is difficult to guarantee that
global variables with external linkage are not addressed, those
variables may be aliased even if their flags indicate that they are not
addressed.  Rather than checking these conditions separately, the
library provides one method to check them all.  The <CODE>is_spilled</CODE>
method returns <CODE>TRUE</CODE> for variables that are static, addressed, or
aggregates.  Variables that are not spilled can then be targeted for
optimization.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_55.html">previous</A>, <A HREF="suif1_57.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
